Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
+++ protocols/yahoo/libyahoo2.c	(revision 9034ba002b8945aee0f905b928bb0f60da9afe9f)
@@ -108,5 +108,7 @@
 #endif
 
-static int yahoo_send_data(int fd, void *data, int len);
+static int yahoo_send_data(void *fd, void *data, int len);
+static void _yahoo_http_connected(int id, void *fd, int error, void *data);
+static void yahoo_connected(void *fd, int error, void *data);
 
 int yahoo_log_message(char *fmt, ...)
@@ -140,7 +142,13 @@
 
 /* default values for servers */
-static char pager_host[] = "scs.msg.yahoo.com"; 
+static char *default_pager_hosts[] = {	"scs.msg.yahoo.com",
+					"scsa.msg.yahoo.com",
+					"scsb.msg.yahoo.com",
+					"scsc.msg.yahoo.com",
+					NULL};
+
 static int pager_port = 5050;
 static int fallback_ports[] = { 23, 25, 80, 20, 119, 8001, 8002, 5050, 0 };
+
 static char filetransfer_host[] = "filetransfer.msg.yahoo.com";
 static int filetransfer_port = 80;
@@ -153,82 +161,9 @@
 static char profile_url[] = "http://profiles.yahoo.com/";
 
-enum yahoo_service { /* these are easier to see in hex */
-	YAHOO_SERVICE_LOGON = 1,
-	YAHOO_SERVICE_LOGOFF,
-	YAHOO_SERVICE_ISAWAY,
-	YAHOO_SERVICE_ISBACK,
-	YAHOO_SERVICE_IDLE, /* 5 (placemarker) */
-	YAHOO_SERVICE_MESSAGE,
-	YAHOO_SERVICE_IDACT,
-	YAHOO_SERVICE_IDDEACT,
-	YAHOO_SERVICE_MAILSTAT,
-	YAHOO_SERVICE_USERSTAT, /* 0xa */
-	YAHOO_SERVICE_NEWMAIL,
-	YAHOO_SERVICE_CHATINVITE,
-	YAHOO_SERVICE_CALENDAR,
-	YAHOO_SERVICE_NEWPERSONALMAIL,
-	YAHOO_SERVICE_NEWCONTACT,
-	YAHOO_SERVICE_ADDIDENT, /* 0x10 */
-	YAHOO_SERVICE_ADDIGNORE,
-	YAHOO_SERVICE_PING,
-	YAHOO_SERVICE_GOTGROUPRENAME, /* < 1, 36(old), 37(new) */
-	YAHOO_SERVICE_SYSMESSAGE = 0x14,
-	YAHOO_SERVICE_SKINNAME = 0x15,
-	YAHOO_SERVICE_PASSTHROUGH2 = 0x16,
-	YAHOO_SERVICE_CONFINVITE = 0x18,
-	YAHOO_SERVICE_CONFLOGON,
-	YAHOO_SERVICE_CONFDECLINE,
-	YAHOO_SERVICE_CONFLOGOFF,
-	YAHOO_SERVICE_CONFADDINVITE,
-	YAHOO_SERVICE_CONFMSG,
-	YAHOO_SERVICE_CHATLOGON,
-	YAHOO_SERVICE_CHATLOGOFF,
-	YAHOO_SERVICE_CHATMSG = 0x20,
-	YAHOO_SERVICE_GAMELOGON = 0x28,
-	YAHOO_SERVICE_GAMELOGOFF,
-	YAHOO_SERVICE_GAMEMSG = 0x2a,
-	YAHOO_SERVICE_FILETRANSFER = 0x46,
-	YAHOO_SERVICE_VOICECHAT = 0x4A,
-	YAHOO_SERVICE_NOTIFY,
-	YAHOO_SERVICE_VERIFY,
-	YAHOO_SERVICE_P2PFILEXFER,
-	YAHOO_SERVICE_PEERTOPEER = 0x4F,	/* Checks if P2P possible */
-	YAHOO_SERVICE_WEBCAM,
-	YAHOO_SERVICE_AUTHRESP = 0x54,
-	YAHOO_SERVICE_LIST,
-	YAHOO_SERVICE_AUTH = 0x57,
-	YAHOO_SERVICE_AUTHBUDDY = 0x6d,
-	YAHOO_SERVICE_ADDBUDDY = 0x83,
-	YAHOO_SERVICE_REMBUDDY,
-	YAHOO_SERVICE_IGNORECONTACT,	/* > 1, 7, 13 < 1, 66, 13, 0*/
-	YAHOO_SERVICE_REJECTCONTACT,
-	YAHOO_SERVICE_GROUPRENAME = 0x89, /* > 1, 65(new), 66(0), 67(old) */
-	YAHOO_SERVICE_Y7_PING = 0x8A, /* 0 - id and that's it?? */
-	YAHOO_SERVICE_CHATONLINE = 0x96, /* > 109(id), 1, 6(abcde) < 0,1*/
-	YAHOO_SERVICE_CHATGOTO,
-	YAHOO_SERVICE_CHATJOIN,	/* > 1 104-room 129-1600326591 62-2 */
-	YAHOO_SERVICE_CHATLEAVE,
-	YAHOO_SERVICE_CHATEXIT = 0x9b,
-	YAHOO_SERVICE_CHATADDINVITE = 0x9d,
-	YAHOO_SERVICE_CHATLOGOUT = 0xa0,
-	YAHOO_SERVICE_CHATPING,
-	YAHOO_SERVICE_COMMENT = 0xa8,
-	YAHOO_SERVICE_STEALTH = 0xb9,
-	YAHOO_SERVICE_PICTURE_CHECKSUM = 0xbd,
-	YAHOO_SERVICE_PICTURE = 0xbe,
-	YAHOO_SERVICE_PICTURE_UPDATE = 0xc1,
-	YAHOO_SERVICE_PICTURE_UPLOAD = 0xc2,
-	YAHOO_SERVICE_Y6_VISIBILITY = 0xc5,
-	YAHOO_SERVICE_Y6_STATUS_UPDATE = 0xc6,
-	YAHOO_PHOTOSHARE_INIT = 0xd2,	
-	YAHOO_SERVICE_CONTACT_YMSG13 = 0xd6,
-	YAHOO_PHOTOSHARE_PREV = 0xd7,
-	YAHOO_PHOTOSHARE_KEY = 0xd8,
-	YAHOO_PHOTOSHARE_TRANS = 0xda,
-	YAHOO_FILE_TRANSFER_INIT_YMSG13 = 0xdc,
-	YAHOO_FILE_TRANSFER_GET_YMSG13 = 0xdd,
-	YAHOO_FILE_TRANSFER_PUT_YMSG13 = 0xde,
-	YAHOO_SERVICE_YMSG15_STATUS = 0xf0,
-	YAHOO_SERVICE_YMSG15_BUDDY_LIST = 0xf1,
+struct connect_callback_data {
+	struct yahoo_data *yd;
+	int tag;
+	int i;
+	int server_i;
 };
 
@@ -268,7 +203,7 @@
 	struct yahoo_search_state *ys;
 
-	int fd;
+	void *fd;
 	enum yahoo_connection_type type;
-	
+
 	unsigned char *rxqueue;
 	int rxlen;
@@ -289,11 +224,29 @@
 	char *local_host;
 	int conn_type;
+	char **pager_host_list;
 };
 
+static void yahoo_process_ft_connection(struct yahoo_input_data *yid, int over);
+
+static void yahoo_process_filetransfer(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt);
+static void yahoo_process_filetransferinfo(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt);
+static void yahoo_process_filetransferaccept(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt);
+
+static void yahoo_https_auth(struct yahoo_input_data *yid, const char *seed, const char *sn);
+
 static void *_yahoo_default_server_settings()
 {
-	struct yahoo_server_settings *yss = y_new0(struct yahoo_server_settings, 1);
-
-	yss->pager_host = strdup(pager_host);
+	struct yahoo_server_settings *yss =
+		y_new0(struct yahoo_server_settings, 1);
+
+	/* Give preference to the default host list
+	 * Make sure that only one of the two is set at any time 
+	 */
+	yss->pager_host = NULL;
+	yss->pager_host_list = default_pager_hosts;
+
 	yss->pager_port = pager_port;
 	yss->filetransfer_host = strdup(filetransfer_host);
@@ -314,4 +267,5 @@
 	char *svalue;
 	int nvalue;
+	char **pvalue;
 
 	while (1) {
@@ -324,4 +278,10 @@
 			free(yss->pager_host);
 			yss->pager_host = strdup(svalue);
+			yss->pager_host_list = NULL;
+		} else if (!strcmp(key, "pager_host_list")) {
+			pvalue = va_arg(ap, char **);
+			yss->pager_host_list = pvalue;
+			free(yss->pager_host);
+			yss->pager_host = NULL;
 		} else if (!strcmp(key, "pager_port")) {
 			nvalue = va_arg(ap, int);
@@ -384,4 +344,5 @@
 	conns = y_list_prepend(conns, yd);
 }
+
 static struct yahoo_data *find_conn_by_id(int id)
 {
@@ -394,4 +355,5 @@
 	return NULL;
 }
+
 static void del_from_list(struct yahoo_data *yd)
 {
@@ -400,5 +362,6 @@
 
 /* call repeatedly to get the next one */
-static struct yahoo_input_data *find_input_by_id(int id)
+/*
+static struct yahoo_input_data * find_input_by_id(int id)
 {
 	YList *l;
@@ -410,6 +373,8 @@
 	return NULL;
 }
-
-static struct yahoo_input_data *find_input_by_id_and_webcam_user(int id, const char *who)
+*/
+
+static struct yahoo_input_data *find_input_by_id_and_webcam_user(int id,
+	const char *who)
 {
 	YList *l;
@@ -417,8 +382,9 @@
 	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if (yid->type == YAHOO_CONNECTION_WEBCAM && yid->yd->client_id == id 
-				&& yid->wcm && 
-				((who && yid->wcm->user && !strcmp(who, yid->wcm->user)) ||
-				 !(yid->wcm->user && !who)))
+		if (yid->type == YAHOO_CONNECTION_WEBCAM
+			&& yid->yd->client_id == id && yid->wcm && ((who
+					&& yid->wcm->user
+					&& !strcmp(who, yid->wcm->user))
+				|| !(yid->wcm->user && !who)))
 			return yid;
 	}
@@ -426,5 +392,6 @@
 }
 
-static struct yahoo_input_data *find_input_by_id_and_type(int id, enum yahoo_connection_type type)
+static struct yahoo_input_data *find_input_by_id_and_type(int id,
+	enum yahoo_connection_type type)
 {
 	YList *l;
@@ -438,5 +405,5 @@
 }
 
-static struct yahoo_input_data *find_input_by_id_and_fd(int id, int fd)
+static struct yahoo_input_data *find_input_by_id_and_fd(int id, void *fd)
 {
 	YList *l;
@@ -463,5 +430,4 @@
 	return c;
 }
-
 
 extern char *yahoo_crypt(char *, char *);
@@ -528,4 +494,5 @@
 	FREE(yd->cookie_y);
 	FREE(yd->cookie_t);
+	FREE(yd->cookie_b);
 	FREE(yd->cookie_c);
 	FREE(yd->login_cookie);
@@ -543,6 +510,6 @@
 #define YAHOO_PACKET_HDRLEN (4 + 2 + 2 + 2 + 2 + 4 + 4)
 
-static struct yahoo_packet *yahoo_packet_new(enum yahoo_service service, 
-		enum yahoo_status status, int id)
+static struct yahoo_packet *yahoo_packet_new(enum yahoo_service service,
+	enum ypacket_status status, int id)
 {
 	struct yahoo_packet *pkt = y_new0(struct yahoo_packet, 1);
@@ -555,5 +522,6 @@
 }
 
-static void yahoo_packet_hash(struct yahoo_packet *pkt, int key, const char *value)
+static void yahoo_packet_hash(struct yahoo_packet *pkt, int key,
+	const char *value)
 {
 	struct yahoo_pair *pair = y_new0(struct yahoo_pair, 1);
@@ -600,5 +568,6 @@
 			 (((*((buf)+3))&0xff)))
 
-static void yahoo_packet_read(struct yahoo_packet *pkt, unsigned char *data, int len)
+static void yahoo_packet_read(struct yahoo_packet *pkt, unsigned char *data,
+	int len)
 {
 	int pos = 0;
@@ -653,5 +622,6 @@
 			FREE(value);
 			pkt->hash = y_list_append(pkt->hash, pair);
-			DEBUG_MSG(("Key: %d  \tValue: %s", pair->key, pair->value));
+			DEBUG_MSG(("Key: %d  \tValue: %s", pair->key,
+					pair->value));
 		} else {
 			FREE(pair);
@@ -788,10 +758,10 @@
 }
 
-static int yahoo_send_data(int fd, void *data, int len)
+static int yahoo_send_data(void *fd, void *data, int len)
 {
 	int ret;
 	int e;
 
-	if (fd < 0)
+	if (fd == NULL)
 		return -1;
 
@@ -799,5 +769,5 @@
 
 	do {
-		ret = write(fd, data, len);
+		ret = YAHOO_CALLBACK(ext_yahoo_write) (fd, data, len);
 	} while (ret == -1 && errno == EINTR);
 	e = errno;
@@ -838,5 +808,5 @@
 	yid->read_tag = yid->write_tag = 0;
 	if (yid->fd)
-		close(yid->fd);
+		YAHOO_CALLBACK(ext_yahoo_close) (yid->fd);
 	yid->fd = 0;
 	FREE(yid->rxqueue);
@@ -942,5 +912,5 @@
 	else if (!strncasecmp(msg, "GAME", strlen("GAME")))
 		YAHOO_CALLBACK(ext_yahoo_game_notify) (yd->client_id, to, from,
-			stat);
+			stat, ind);
 	else if (!strncasecmp(msg, "WEBCAMINVITE", strlen("WEBCAMINVITE"))) {
 		if (!strcmp(ind, " ")) {
@@ -959,61 +929,6 @@
 }
 
-static void yahoo_process_filetransfer(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
-{
-	struct yahoo_data *yd = yid->yd;
-	char *from = NULL;
-	char *to = NULL;
-	char *msg = NULL;
-	char *url = NULL;
-	long expires = 0;
-
-	char *service = NULL;
-
-	char *filename = NULL;
-	unsigned long filesize = 0L;
-
-	YList *l;
-	for (l = pkt->hash; l; l = l->next) {
-		struct yahoo_pair *pair = l->data;
-		if (pair->key == 4)
-			from = pair->value;
-		if (pair->key == 5)
-			to = pair->value;
-		if (pair->key == 14)
-			msg = pair->value;
-		if (pair->key == 20)
-			url = pair->value;
-		if (pair->key == 38)
-			expires = atol(pair->value);
-
-		if (pair->key == 27)
-			filename = pair->value;
-		if (pair->key == 28)
-			filesize = atol(pair->value);
-
-		if (pair->key == 49)
-			service = pair->value;
-	}
-
-	if (pkt->service == YAHOO_SERVICE_P2PFILEXFER) {
-		if (strcmp("FILEXFER", service) != 0) {
-			WARNING(("unhandled service 0x%02x", pkt->service));
-			yahoo_dump_unhandled(pkt);
-			return;
-		}
-	}
-
-	if (msg) {
-		char *tmp;
-		tmp = strchr(msg, '\006');
-		if (tmp)
-			*tmp = '\0';
-	}
-	if (url && from)
-		YAHOO_CALLBACK(ext_yahoo_got_file) (yd->client_id, to, from, url, expires, msg, filename, filesize);
-
-}
-
-static void yahoo_process_conference(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_conference(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -1090,8 +1005,7 @@
 		break;
 	case YAHOO_SERVICE_CONFADDINVITE:
-		if (pkt->status == 2)
-			;
-		else
-			YAHOO_CALLBACK(ext_yahoo_got_conf_invite) (yd->client_id, id, host, room, msg, members);
+		if (pkt->status == 1)
+			YAHOO_CALLBACK(ext_yahoo_got_conf_invite) (yd->
+				client_id, id, host, room, msg, members);
 		break;
 	case YAHOO_SERVICE_CONFDECLINE:
@@ -1134,5 +1048,5 @@
 	int chaterr = 0;
 	YList *l;
-	
+
 	yahoo_dump_unhandled(pkt);
 	for (l = pkt->hash; l; l = l->next) {
@@ -1285,4 +1199,5 @@
 		char *msg;
 		int utf8;
+		char *gunk;
 	} *message = y_new0(struct m, 1);
 
@@ -1298,5 +1213,8 @@
 		else if (pair->key == 97)
 			message->utf8 = atoi(pair->value);
-			/* user message */  /* sys message */
+		/* This comes when the official client sends us a message */
+		else if (pair->key == 429)
+			message->gunk = pair->value;
+		/* user message *//* sys message */
 		else if (pair->key == 14 || pair->key == 16)
 			message->msg = pair->value;
@@ -1318,11 +1236,36 @@
 		message = l->data;
 		if (pkt->service == YAHOO_SERVICE_SYSMESSAGE) {
-			YAHOO_CALLBACK(ext_yahoo_system_message) (yd->client_id, message->msg);
+			YAHOO_CALLBACK(ext_yahoo_system_message) (yd->client_id,
+				message->to, message->from, message->msg);
 		} else if (pkt->status <= 2 || pkt->status == 5) {
-			YAHOO_CALLBACK(ext_yahoo_got_im) (yd->client_id, message->to, message->from, message->msg, message->tm, pkt->status, message->utf8);
+			/* Confirm message receipt if we got the gunk */
+			if(message->gunk) {
+				struct yahoo_packet *outpkt;
+                        
+				outpkt = yahoo_packet_new(YAHOO_SERVICE_MESSAGE_CONFIRM,
+					YPACKET_STATUS_DEFAULT, 0);
+				yahoo_packet_hash(outpkt, 1, yd->user);
+				yahoo_packet_hash(outpkt, 5, message->from);
+				yahoo_packet_hash(outpkt, 302, "430");
+				yahoo_packet_hash(outpkt, 430, message->gunk);
+				yahoo_packet_hash(outpkt, 303, "430");
+				yahoo_packet_hash(outpkt, 450, "0");
+				yahoo_send_packet(yid, outpkt, 0);
+                        
+				yahoo_packet_free(outpkt);
+			}
+
+			if (!strcmp(message->msg, "<ding>"))
+				YAHOO_CALLBACK(ext_yahoo_got_buzz) (yd->client_id,
+					message->to, message->from, message->tm);
+			else
+				YAHOO_CALLBACK(ext_yahoo_got_im) (yd->client_id,
+					message->to, message->from, message->msg,
+					message->tm, pkt->status, message->utf8);
 		} else if (pkt->status == 0xffffffff) {
-			YAHOO_CALLBACK(ext_yahoo_error) (yd->client_id, message->msg, 0, E_SYSTEM);
-		}
-		free(message);
+			YAHOO_CALLBACK(ext_yahoo_error) (yd->client_id,
+				message->msg, 0, E_SYSTEM);
+		}
+		FREE(message);
 	}
 
@@ -1330,4 +1273,27 @@
 }
 
+/*
+ * Here's what multi-level packets look like. Data in brackets is the value.
+ *
+ * 3 level:
+ * =======
+ * 
+ * 302 (318) - Beginning level 1
+ * 	300 (318) - Begin level 2
+ * 	302 (319) - End level 2 header
+ * 		300 (319) - Begin level 3
+ * 		301 (319) - End level 3
+ * 	303 (319) - End level 2
+ * 303 (318) - End level 1
+ *
+ * 2 level:
+ * =======
+ *
+ * 302 (315) - Beginning level 1
+ * 	300 (315) - Begin level 2
+ * 	301 (315) - End level 2
+ * 303 (315) - End level 1
+ *
+ */
 static void yahoo_process_status(struct yahoo_input_data *yid,
 	struct yahoo_packet *pkt)
@@ -1721,22 +1687,20 @@
 	char *url = NULL;
 
-	if ( pkt->status != 1 )
+	if (pkt->status != 1)
 		return;		/* something went wrong */
-	
-	for (l = pkt->hash; l; l = l->next)
-	{
+
+	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 
-		switch(pair->key)
-		{
-			case 5:		/* we */
-				break;
-			case 20:		/* url */
-				url = pair->value;
-				break;
-			case 27:		/* local filename */
-				break;
-			case 38:		/* time */
-				break;
+		switch (pair->key) {
+		case 5:	/* we */
+			break;
+		case 20:	/* url */
+			url = pair->value;
+			break;
+		case 27:	/* local filename */
+			break;
+		case 38:	/* time */
+			break;
 		}
 	}
@@ -1745,538 +1709,41 @@
 }
 
-static void yahoo_process_auth_pre_0x0b(struct yahoo_input_data *yid, 
-		const char *seed, const char *sn)
-{
-	struct yahoo_data *yd = yid->yd;
-	
-	/* So, Yahoo has stopped supporting its older clients in India, and 
-	 * undoubtedly will soon do so in the rest of the world.
-	 * 
-	 * The new clients use this authentication method.  I warn you in 
-	 * advance, it's bizzare, convoluted, inordinately complicated.  
-	 * It's also no more secure than crypt() was.  The only purpose this 
-	 * scheme could serve is to prevent third part clients from connecting 
-	 * to their servers.
-	 *
-	 * Sorry, Yahoo.
+void yahoo_login(int id, int initial)
+{
+	struct yahoo_data *yd = find_conn_by_id(id);
+	struct connect_callback_data *ccd;
+	struct yahoo_server_settings *yss;
+	int tag;
+
+	char *host;
+
+	struct yahoo_input_data *yid = y_new0(struct yahoo_input_data, 1);
+	yid->yd = yd;
+	yid->type = YAHOO_CONNECTION_PAGER;
+	inputs = y_list_prepend(inputs, yid);
+
+	yd->initial_status = initial;
+	yss = yd->server_settings;
+
+	ccd = y_new0(struct connect_callback_data, 1);
+	ccd->yd = yd;
+
+	host = yss->pager_host;
+
+	if (!host)
+		host = yss->pager_host_list[0];
+
+	tag = YAHOO_CALLBACK(ext_yahoo_connect_async) (yd->client_id,
+		host, yss->pager_port, yahoo_connected, ccd, 0);
+
+	/*
+	 * if tag <= 0, then callback has already been called
+	 * so ccd will have been freed
 	 */
-
-	struct yahoo_packet *pack;
-	
-	md5_byte_t result[16];
-	md5_state_t ctx;
-	char *crypt_result;
-	unsigned char *password_hash = malloc(25);
-	unsigned char *crypt_hash = malloc(25);
-	unsigned char *hash_string_p = malloc(50 + strlen(sn));
-	unsigned char *hash_string_c = malloc(50 + strlen(sn));
-	
-	char checksum;
-	
-	int sv;
-	
-	unsigned char *result6 = malloc(25);
-	unsigned char *result96 = malloc(25);
-
-	sv = seed[15];
-	sv = (sv % 8) % 5;
-
-	md5_init(&ctx);
-	md5_append(&ctx, (md5_byte_t *)yd->password, strlen(yd->password));
-	md5_finish(&ctx, result);
-	to_y64(password_hash, result, 16);
-	
-	md5_init(&ctx);
-	crypt_result = yahoo_crypt(yd->password, "$1$_2S43d5f$");  
-	md5_append(&ctx, (md5_byte_t *)crypt_result, strlen(crypt_result));
-	md5_finish(&ctx, result);
-	to_y64(crypt_hash, result, 16);
-	free(crypt_result);
-
-	switch (sv) {
-	case 0:
-		checksum = seed[seed[7] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, password_hash, yd->user, seed);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, crypt_hash, yd->user, seed);
-		break;
-	case 1:
-		checksum = seed[seed[9] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, yd->user, seed, password_hash);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, yd->user, seed, crypt_hash);
-		break;
-	case 2:
-		checksum = seed[seed[15] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, seed, password_hash, yd->user);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, seed, crypt_hash, yd->user);
-		break;
-	case 3:
-		checksum = seed[seed[1] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, yd->user, password_hash, seed);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, yd->user, crypt_hash, seed);
-		break;
-	case 4:
-		checksum = seed[seed[3] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, password_hash, seed, yd->user);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, crypt_hash, seed, yd->user);
-		break;
-	}
-		
-	md5_init(&ctx);  
-	md5_append(&ctx, (md5_byte_t *)hash_string_p, strlen((char *)hash_string_p));
-	md5_finish(&ctx, result);
-	to_y64(result6, result, 16);
-
-	md5_init(&ctx);  
-	md5_append(&ctx, (md5_byte_t *)hash_string_c, strlen((char *)hash_string_c));
-	md5_finish(&ctx, result);
-	to_y64(result96, result, 16);
-
-	pack = yahoo_packet_new(YAHOO_SERVICE_AUTHRESP, yd->initial_status, yd->session_id);
-	yahoo_packet_hash(pack, 0, yd->user);
-	yahoo_packet_hash(pack, 6, (char *)result6);
-	yahoo_packet_hash(pack, 96, (char *)result96);
-	yahoo_packet_hash(pack, 1, yd->user);
-		
-	yahoo_send_packet(yid, pack, 0);
-		
-	FREE(result6);
-	FREE(result96);
-	FREE(password_hash);
-	FREE(crypt_hash);
-	FREE(hash_string_p);
-	FREE(hash_string_c);
-
-	yahoo_packet_free(pack);
-
-}
-
-/*
- * New auth protocol cracked by Cerulean Studios and sent in to Gaim
- */
-static void yahoo_process_auth_0x0b(struct yahoo_input_data *yid, const char *seed, const char *sn)
-{
-	struct yahoo_packet *pack = NULL;
-	struct yahoo_data *yd = yid->yd;
-
-	md5_byte_t         result[16];
-	md5_state_t        ctx;
-
-	sha1_state_t       ctx1;
-	sha1_state_t       ctx2;
-
-	char *alphabet1 = "FBZDWAGHrJTLMNOPpRSKUVEXYChImkwQ";
-	char *alphabet2 = "F0E1D2C3B4A59687abcdefghijklmnop";
-
-	char *challenge_lookup = "qzec2tb3um1olpar8whx4dfgijknsvy5";
-	char *operand_lookup = "+|&%/*^-";
-	char *delimit_lookup = ",;";
-
-	unsigned char *password_hash = malloc(25);
-	unsigned char *crypt_hash = malloc(25);
-	char *crypt_result = NULL;
-	unsigned char pass_hash_xor1[64];
-	unsigned char pass_hash_xor2[64];
-	unsigned char crypt_hash_xor1[64];
-	unsigned char crypt_hash_xor2[64];
-	unsigned char chal[7];
-	char resp_6[100];
-	char resp_96[100];
-
-	unsigned char digest1[20];
-	unsigned char digest2[20];
-	unsigned char magic_key_char[4];
-	const unsigned char *magic_ptr;
-
-	unsigned int magic[64];
-	unsigned int magic_work = 0;
-
-	char comparison_src[20];
-
-	int x, j, i;
-	int cnt = 0;
-	int magic_cnt = 0;
-	int magic_len;
-	int depth =0, table =0;
-
-	memset(&pass_hash_xor1, 0, 64);
-	memset(&pass_hash_xor2, 0, 64);
-	memset(&crypt_hash_xor1, 0, 64);
-	memset(&crypt_hash_xor2, 0, 64);
-	memset(&digest1, 0, 20);
-	memset(&digest2, 0, 20);
-	memset(&magic, 0, 64);
-	memset(&resp_6, 0, 100);
-	memset(&resp_96, 0, 100);
-	memset(&magic_key_char, 0, 4);
-
-	/* 
-	 * Magic: Phase 1.  Generate what seems to be a 30 
-	 * byte value (could change if base64
-	 * ends up differently?  I don't remember and I'm 
-	 * tired, so use a 64 byte buffer.
-	 */
-
-	magic_ptr = (unsigned char *)seed;
-
-	while (*magic_ptr != 0) {
-		char *loc;
-
-		/* Ignore parentheses.  */
-
-		if (*magic_ptr == '(' || *magic_ptr == ')') {
-			magic_ptr++;
-			continue;
-		}
-
-		/* Characters and digits verify against 
-		   the challenge lookup.
-		*/
-
-		if (isalpha(*magic_ptr) || isdigit(*magic_ptr)) {
-			loc = strchr(challenge_lookup, *magic_ptr);
-			if (!loc) {
-				/* This isn't good */
-				continue;
-			}
-
-			/* Get offset into lookup table and lsh 3. */
-
-			magic_work = loc - challenge_lookup;
-			magic_work <<= 3;
-
-			magic_ptr++;
-			continue;
-		} else {
-			unsigned int local_store;
-
-			loc = strchr(operand_lookup, *magic_ptr);
-			if (!loc) {
-				/* Also not good. */
-				continue;
-			}
-
-			local_store = loc - operand_lookup;
-
-			/* Oops; how did this happen? */
-			if (magic_cnt >= 64) 
-				break;
-
-			magic[magic_cnt++] = magic_work | local_store;
-			magic_ptr++;
-			continue;
-		}
-	}
-
-	magic_len = magic_cnt;
-	magic_cnt = 0;
-
-	/* Magic: Phase 2.  Take generated magic value and 
-	 * sprinkle fairy dust on the values. */
-
-	for (magic_cnt = magic_len-2; magic_cnt >= 0; magic_cnt--) {
-		unsigned char byte1;
-		unsigned char byte2;
-
-		/* Bad.  Abort.
-		 */
-		if (magic_cnt >= magic_len) {
-			WARNING(("magic_cnt(%d)  magic_len(%d)", magic_cnt, magic_len))
-			break;
-		}
-
-		byte1 = magic[magic_cnt];
-		byte2 = magic[magic_cnt+1];
-
-		byte1 *= 0xcd;
-		byte1 ^= byte2;
-
-		magic[magic_cnt+1] = byte1;
-	}
-
-	/* Magic: Phase 3.  This computes 20 bytes.  The first 4 bytes are used as our magic 
-	 * key (and may be changed later); the next 16 bytes are an MD5 sum of the magic key 
-	 * plus 3 bytes.  The 3 bytes are found by looping, and they represent the offsets 
-	 * into particular functions we'll later call to potentially alter the magic key. 
-	 * 
-	 * %-) 
-	 */ 
-	
-	magic_cnt = 1; 
-	x = 0; 
-	
-	do { 
-		unsigned int bl = 0;  
-		unsigned int cl = magic[magic_cnt++]; 
-		
-		if (magic_cnt >= magic_len) 
-			break; 
-		
-		if (cl > 0x7F) { 
-			if (cl < 0xe0)  
-				bl = cl = (cl & 0x1f) << 6;  
-			else { 
-				bl = magic[magic_cnt++];  
-                              cl = (cl & 0x0f) << 6;  
-                              bl = ((bl & 0x3f) + cl) << 6;  
-			}  
-			
-			cl = magic[magic_cnt++];  
-			bl = (cl & 0x3f) + bl;  
-		} else 
-			bl = cl;  
-		
-		comparison_src[x++] = (bl & 0xff00) >> 8;  
-		comparison_src[x++] = bl & 0xff;  
-	} while (x < 20); 
-
-	/* Dump magic key into a char for SHA1 action. */
-	
-		
-	for (x = 0; x < 4; x++) 
-		magic_key_char[x] = comparison_src[x];
-
-	/* Compute values for recursive function table! */
-	memcpy( chal, magic_key_char, 4 );
-        x = 1;
-	for ( i = 0; i < 0xFFFF && x; i++ )
-	{
-		for ( j = 0; j < 5 && x; j++ )
-		{
-			chal[4] = i;
-			chal[5] = i >> 8;
-			chal[6] = j;
-			md5_init( &ctx );
-			md5_append( &ctx, chal, 7 );
-			md5_finish( &ctx, result );
-			if ( memcmp( comparison_src + 4, result, 16 ) == 0 )
-			{
-				depth = i;
-				table = j;
-				x = 0;
-			}
-		}
-	}
-
-	/* Transform magic_key_char using transform table */
-	x = magic_key_char[3] << 24  | magic_key_char[2] << 16 
-		| magic_key_char[1] << 8 | magic_key_char[0];
-	x = yahoo_xfrm( table, depth, x );
-	x = yahoo_xfrm( table, depth, x );
-	magic_key_char[0] = x & 0xFF;
-	magic_key_char[1] = x >> 8 & 0xFF;
-	magic_key_char[2] = x >> 16 & 0xFF;
-	magic_key_char[3] = x >> 24 & 0xFF;
-
-	/* Get password and crypt hashes as per usual. */
-	md5_init(&ctx);
-	md5_append(&ctx, (md5_byte_t *)yd->password,  strlen(yd->password));
-	md5_finish(&ctx, result);
-	to_y64(password_hash, result, 16);
-
-	md5_init(&ctx);
-	crypt_result = yahoo_crypt(yd->password, "$1$_2S43d5f$");  
-	md5_append(&ctx, (md5_byte_t *)crypt_result, strlen(crypt_result));
-	md5_finish(&ctx, result);
-	to_y64(crypt_hash, result, 16);
-	free(crypt_result);
-
-	/* Our first authentication response is based off 
-	 * of the password hash. */
-
-	for (x = 0; x < (int)strlen((char *)password_hash); x++) 
-		pass_hash_xor1[cnt++] = password_hash[x] ^ 0x36;
-
-	if (cnt < 64) 
-		memset(&(pass_hash_xor1[cnt]), 0x36, 64-cnt);
-
-	cnt = 0;
-
-	for (x = 0; x < (int)strlen((char *)password_hash); x++) 
-		pass_hash_xor2[cnt++] = password_hash[x] ^ 0x5c;
-
-	if (cnt < 64) 
-		memset(&(pass_hash_xor2[cnt]), 0x5c, 64-cnt);
-
-	sha1_init(&ctx1);
-	sha1_init(&ctx2);
-
-	/* The first context gets the password hash XORed 
-	 * with 0x36 plus a magic value
-	 * which we previously extrapolated from our 
-	 * challenge. */
-
-	sha1_append(&ctx1, pass_hash_xor1, 64);
-	if (j >= 3 )
-		ctx1.Length_Low = 0x1ff;
-	sha1_append(&ctx1, magic_key_char, 4);
-	sha1_finish(&ctx1, digest1);
-
-	 /* The second context gets the password hash XORed 
-	  * with 0x5c plus the SHA-1 digest
-	  * of the first context. */
-
-	sha1_append(&ctx2, pass_hash_xor2, 64);
-	sha1_append(&ctx2, digest1, 20);
-	sha1_finish(&ctx2, digest2);
-
-	/* Now that we have digest2, use it to fetch 
-	 * characters from an alphabet to construct
-	 * our first authentication response. */
-
-	for (x = 0; x < 20; x += 2) {
-		unsigned int val = 0;
-		unsigned int lookup = 0;
-		char byte[6];
-
-		memset(&byte, 0, 6);
-
-		/* First two bytes of digest stuffed 
-		 *  together.
-		 */
-
-		val = digest2[x];
-		val <<= 8;
-		val += digest2[x+1];
-
-		lookup = (val >> 0x0b);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet1))
-			break;
-		sprintf(byte, "%c", alphabet1[lookup]);
-		strcat(resp_6, byte);
-		strcat(resp_6, "=");
-
-		lookup = (val >> 0x06);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet2))
-			break;
-		sprintf(byte, "%c", alphabet2[lookup]);
-		strcat(resp_6, byte);
-
-		lookup = (val >> 0x01);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet2))
-			break;
-		sprintf(byte, "%c", alphabet2[lookup]);
-		strcat(resp_6, byte);
-
-		lookup = (val & 0x01);
-		if (lookup >= strlen(delimit_lookup))
-			break;
-		sprintf(byte, "%c", delimit_lookup[lookup]);
-		strcat(resp_6, byte);
-	}
-
-	/* Our second authentication response is based off 
-	 * of the crypto hash. */
-
-	cnt = 0;
-	memset(&digest1, 0, 20);
-	memset(&digest2, 0, 20);
-
-	for (x = 0; x < (int)strlen((char *)crypt_hash); x++) 
-		crypt_hash_xor1[cnt++] = crypt_hash[x] ^ 0x36;
-
-	if (cnt < 64) 
-		memset(&(crypt_hash_xor1[cnt]), 0x36, 64-cnt);
-
-	cnt = 0;
-
-	for (x = 0; x < (int)strlen((char *)crypt_hash); x++) 
-		crypt_hash_xor2[cnt++] = crypt_hash[x] ^ 0x5c;
-
-	if (cnt < 64) 
-		memset(&(crypt_hash_xor2[cnt]), 0x5c, 64-cnt);
-
-	sha1_init(&ctx1);
-	sha1_init(&ctx2);
-
-	/* The first context gets the password hash XORed 
-	 * with 0x36 plus a magic value
-	 * which we previously extrapolated from our 
-	 * challenge. */
-
-	sha1_append(&ctx1, crypt_hash_xor1, 64);
-	if (j >= 3 )
-		ctx1.Length_Low = 0x1ff;
-	sha1_append(&ctx1, magic_key_char, 4);
-	sha1_finish(&ctx1, digest1);
-
-	/* The second context gets the password hash XORed 
-	 * with 0x5c plus the SHA-1 digest
-	 * of the first context. */
-
-	sha1_append(&ctx2, crypt_hash_xor2, 64);
-	sha1_append(&ctx2, digest1, 20);
-	sha1_finish(&ctx2, digest2);
-
-	/* Now that we have digest2, use it to fetch 
-	 * characters from an alphabet to construct
-	 * our first authentication response.  */
-
-	for (x = 0; x < 20; x += 2) {
-		unsigned int val = 0;
-		unsigned int lookup = 0;
-
-		char byte[6];
-
-		memset(&byte, 0, 6);
-
-		/* First two bytes of digest stuffed 
-		 *  together. */
-
-		val = digest2[x];
-		val <<= 8;
-		val += digest2[x+1];
-
-		lookup = (val >> 0x0b);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet1))
-			break;
-		sprintf(byte, "%c", alphabet1[lookup]);
-		strcat(resp_96, byte);
-		strcat(resp_96, "=");
-
-		lookup = (val >> 0x06);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet2))
-			break;
-		sprintf(byte, "%c", alphabet2[lookup]);
-		strcat(resp_96, byte);
-
-		lookup = (val >> 0x01);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet2))
-			break;
-		sprintf(byte, "%c", alphabet2[lookup]);
-		strcat(resp_96, byte);
-
-		lookup = (val & 0x01);
-		if (lookup >= strlen(delimit_lookup))
-			break;
-		sprintf(byte, "%c", delimit_lookup[lookup]);
-		strcat(resp_96, byte);
-	}
-
-	pack = yahoo_packet_new(YAHOO_SERVICE_AUTHRESP, yd->initial_status, yd->session_id);
-	yahoo_packet_hash(pack, 0, sn);
-	yahoo_packet_hash(pack, 6, resp_6);
-	yahoo_packet_hash(pack, 96, resp_96);
-	yahoo_packet_hash(pack, 1, sn);
-	yahoo_send_packet(yid, pack, 0);
-	yahoo_packet_free(pack);
-
-	free(password_hash);
-	free(crypt_hash);
+	if (tag > 0)
+		ccd->tag = tag;
+	else if (tag < 0)
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+			YAHOO_LOGIN_SOCK, NULL);
 }
 
@@ -2328,5 +1795,5 @@
 }
 
-static void yahoo_process_auth_0x10(struct yahoo_input_data *yid, const char *seed, const char *sn)
+static void yahoo_https_auth(struct yahoo_input_data *yid, const char *seed, const char *sn)
 {
 	struct yahoo_https_auth_data *had = g_new0(struct yahoo_https_auth_data, 1);
@@ -2479,44 +1946,45 @@
 }
 
-static void yahoo_process_auth(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_auth(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *seed = NULL;
-	char *sn   = NULL;
+	char *sn = NULL;
 	YList *l = pkt->hash;
 	int m = 0;
+	struct yahoo_data *yd = yid->yd;
 
 	while (l) {
 		struct yahoo_pair *pair = l->data;
-		if (pair->key == 94)
+
+		switch (pair->key) {
+		case 94:
 			seed = pair->value;
-		if (pair->key == 1)
+			break;
+		case 1:
 			sn = pair->value;
-		if (pair->key == 13)
+			break;
+		case 13:
 			m = atoi(pair->value);
+			break;
+		}
 		l = l->next;
 	}
 
-	if (!seed) 
-		return;
-
-	switch (m) {
-		case 0:
-			yahoo_process_auth_pre_0x0b(yid, seed, sn);
-			break;
-		case 1:
-			yahoo_process_auth_0x0b(yid, seed, sn);
-			break;
-		case 2:
-			yahoo_process_auth_0x10(yid, seed, sn);
-			break;
-		default:
-			/* call error */
-			WARNING(("unknown auth type %d", m));
-			yahoo_process_auth_0x0b(yid, seed, sn);
-			break;
-	}
-}
-
-static void yahoo_process_auth_resp(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+	if (!seed)
+		return;
+
+	if (m==2)
+		yahoo_https_auth(yid, seed, sn);
+	else {
+		/* call error */
+		WARNING(("unknown auth type %d", m));
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+			YAHOO_LOGIN_UNKNOWN, NULL);
+	}
+}
+
+static void yahoo_process_auth_resp(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -2524,5 +1992,5 @@
 	char *handle;
 	char *url = NULL;
-	int login_status = 0;
+	int login_status = -1;
 
 	YList *l;
